/*********************************************************************
 * |NX
 *  K{t@C
 *      Cu
 *        AdoEnums.js
 *        Binary.js
 *        Common.js
 *        Date.js
 *        String.js
 *        FileSystem.js
 *      convert.js
 *      util.vbs
 * -------------------------------------------------------------------
 * 2010/11/03 VK쐬
 * 2011/04/16 DM11Gp`ǉ
 * -------------------------------------------------------------------
 * Copyright(C) 2010 ASANO, Sei (http://sei.qee.jp/docs/)
 *********************************************************************/
var pomeraDicEnum = {
	defaultModel : "DM10" //ftHgςꍇ́A𑼂̃fɏ
	,model : { //Ήf𑝂₵ꍇ́Aɒ`ǉ
		  DM5 : { MAGIC_NUMBER:0x2F6C, FILE_SIZE:0x2F6C+0x10 }
		,DM10 : { MAGIC_NUMBER:0x2F08, FILE_SIZE:0x2F08+0x10 }
		,DM11G: { MAGIC_NUMBER:0x38CA, FILE_SIZE:0x38CA+0x10 }
		,DM20 : { MAGIC_NUMBER:0x83C8, FILE_SIZE:0x83C8+0x10 }
	}
	,num : {
		head : {
			CHECK_SUM_START : 0x04
		}
		,data : {
			START : 0x0C
		}
		,learned : {
			SIZE : 0x2404
		}
		,user : {
			 HEADER_START : 0x2410
			,COUNT_START  : 0x2412
			,OFFSET_START : 0x2414
			,OFFSET_DEFAULT : 0xFFFF
			,OFFSET_COUNT : 256
			,DATA_START : 0x2614
			,HINSHI_IPPAN : 1
			,YOMI_LEN_MAX : 16 //bytes
			,WORD_LEN_MAX : 36 //bytes
		}
	}
}
var pomeraDicHinshiList = [
	null //dummy
	, "ʖ"
	, "ŗL"
	, "ŗLn"
	, "ŗLgD"
	, "ŗL"
	, "T"
	, "U"
	, "`"
	, "Ɨ"
	, "P"
	, "A̎"
	, "ڑ"
	, ""
	, "ړ"
	, "ڔ"
	, ""
	, "Jsܒi"
	, "Ksܒi"
	, "Tsܒi"
	, "^sܒi"
	, "isܒi"
	, "nsܒi"
	, "osܒi"
	, "}sܒi"
	, "sܒi"
	, "sܒi"
	, "i"
	, "Jϓ"
	, "Tϓ"
	, "Uϓ"
	, "`e"
	, "`e"
	, ""
];
var pomeraDicUserWordOffsetIndex = {
	            "!":0x21, '"':0x22, "#":0x23, "$":0x24, "%":0x25, "&":0x26, "'":0x27
	, "(":0x28, ")":0x29, "*":0x2A, "+":0x2B, ",":0x2C, "-":0x2D, ".":0x2E, "/":0x2F
	, "0":0x30, "1":0x31, "2":0x32, "3":0x33, "4":0x34, "5":0x35, "6":0x36, "7":0x37
	, "8":0x38, "9":0x39, ":":0x3A, ";":0x3B, "<":0x3C, "=":0x3D, ">":0x3E, "?":0x3F
	, "@":0x40, "A":0x41, "B":0x42, "C":0x43, "D":0x44, "E":0x45, "F":0x46, "G":0x47
	, "H":0x48, "I":0x49, "J":0x4A, "K":0x4B, "L":0x4C, "M":0x4D, "N":0x4E, "O":0x4F
	, "P":0x50, "Q":0x51, "R":0x52, "S":0x53, "T":0x54, "U":0x55, "V":0x56, "W":0x57
	, "X":0x58, "Y":0x59, "Z":0x5A, "[":0x5B,"\\":0x5C, "]":0x5D, "^":0x5E, "_":0x5F
	, "`":0x60, "a":0x61, "b":0x62, "c":0x63, "d":0x64, "e":0x65, "f":0x66, "g":0x67
	, "h":0x68, "i":0x69, "j":0x6A, "k":0x6B, "l":0x6C, "m":0x6D, "n":0x6E, "o":0x6F
	, "p":0x70, "q":0x71, "r":0x72, "s":0x73, "t":0x74, "u":0x75, "v":0x76, "w":0x77
	, "x":0x78, "y":0x79, "z":0x7A, "{":0x7B, "|":0x7C, "}":0x7D, "~":0x7E
	          , "":0xA1, "":0xA2, "":0xA3, "":0xA4, "":0xA5, "":0xA6, "":0xA7
	, "":0xA8, "":0xA9, "":0xAA, "":0xAB, "":0xAC, "":0xAD, "":0xAE, "":0xAF
	, "":0xB0, "":0xB1, "":0xB2, "":0xB3, "":0xB4, "":0xB5, "":0xB6, "":0xB7
	, "":0xB8, "":0xB9, "":0xBA, "":0xBB, "":0xBC, "":0xBD, "":0xBE, "":0xBF
	, "":0xC0, "":0xC1, "":0xC2, "":0xC3, "":0xC4, "":0xC5, "":0xC6, "":0xC7
	, "":0xC8, "":0xC9, "":0xCA, "":0xCB, "":0xCC, "":0xCD, "":0xCE, "":0xCF
	, "":0xD0, "":0xD1, "":0xD2, "":0xD3, "":0xD4, "":0xD5, "":0xD6, "":0xD7
	, "":0xD8, "":0xD9, "":0xDA, "":0xDB, "":0xDC, "":0xDD, "":0xDE, "":0xDF
}
//ǂݐ擪Ɏg镶
var pomeraDicUserWord_yomiValidLetterTop = 
	'#$%&*+/0123456789:;<=>@ABCDEFGHIJKLMNOPQRSTUVWXYZ_abcdefghijklmnopqrstuvwxyz'
	+ '';
//擪ȊO̓ǂ݂Ɏg镶
var pomeraDicUserWord_yomiInvalidLetterBody = 
	'#$%&*+-/0123456789:;<=>@ABCDEFGHIJKLMNOPQRSTUVWXYZ_abcdefghijklmnopqrstuvwxyz'
	+ '';
/*********************************************************************
 * |[Uo^PNX
 *********************************************************************/
function PomeraDicUserWord() {
	this.len = 0;
	this.ylen = 0;
	this.yomi_bin = null;
	this.yomi_han = null;
	this.yomi_zen = null;
	this.word_bin = null;
	this.word_str = null;
	this.hinshi = pomeraDicEnum.num.user.HINSHI_IPPAN; //l͈ʖƂ
}
/*********************************************************************
 * |NX
 *********************************************************************/
function PomeraDic() {
	this.binObj = new Binary();
	this.stream = new ActiveXObject("ADODB.Stream");
	this.resetAll();
}
/*********************************************************************
 * |B
 * -------------------------------------------------------------------
 * [] Ȃ
 * [߂] Ȃ
 *********************************************************************/
PomeraDic.prototype.resetAll = function() {
	this.originalFileName = null;
	this.original = null; //̃oCiXg[
	this.modelId = null; //pomeraDicEnum.model̃L[̂ꂩ
	this.fileSize = 0;
	this.lastError = null;

	this.header = new Object();
	this.header.magicNumber = 0;
	this.header.checkSum = 0;

	this.resetUserWord();
}
/*********************************************************************
 * |̃[Uo^Pf[^B
 * -------------------------------------------------------------------
 * [] Ȃ
 * [߂] Ȃ
 *********************************************************************/
PomeraDic.prototype.resetUserWord = function() {
	this.userWord = new Object();
	this.userWord.header = new Object();
	this.userWord.header.size = 0;
	this.userWord.header.count = 0;
	this.userWord.header.offset = new Array(pomeraDicEnum.num.user.OFFSET_COUNT);
	this.userWord.data = new Array();
	this.resetUserWordOffset();
}
/*********************************************************************
 * |̃[Uo^Pf[^̂AItZbgݒ肷B
 * -------------------------------------------------------------------
 * [] Ȃ
 * [߂] Ȃ
 *********************************************************************/
PomeraDic.prototype.resetUserWordOffset = function() {
	for (var i=0 ; i<this.userWord.header.offset.length ; i++) {
		this.userWord.header.offset[i] = pomeraDicEnum.num.user.OFFSET_DEFAULT;
	}
}
/*********************************************************************
 * |AfɊÂďݒ肷B
 * -------------------------------------------------------------------
 * [] modelId : fIDBpomeraDicEnum.modelɂȂꍇ
 *                  pomeraDicEnum.defaultModelőւB
 * [߂] Ȃ
 *********************************************************************/
PomeraDic.prototype.initialize = function(modelId) {
	this.resetAll();
	var define = pomeraDicEnum.model[modelId];
	if (!define) pomeraDicEnum.model[pomeraDicEnum.defaultModel];
	this.modelId = modelId;
	this.fileSize = define.FILE_SIZE;
	this.header.magicNumber = define.MAGIC_NUMBER;
	this.header.checkSum = 0xFF * 2 * pomeraDicEnum.num.user.OFFSET_COUNT;
}
/*********************************************************************
 * w肳ꂽt@C[hB
 * -------------------------------------------------------------------
 * [] fileName : tpX̃t@C
 * [߂] true:IAfalse:G[(lastErrorɃG[e)
 *********************************************************************/
PomeraDic.prototype.loadFromBinaryFile = function(fileName) {
	this.lastError = null;
	if (!fileSystem.fso.fileExists(fileName)) {
		this.lastError("w肳ꂽt@C͂܂");
		return false;
	}
	var stream = this.stream;
	stream.Type = adoEnums.streamType.adTypeBinary;
	stream.Open();
	try {
		if (!this.loadFromBinaryFileLoad(fileName)) return;
		this.originalFileName = fileName;
		this.original = stream.Read(stream.size);
		stream.Position = 0;
		if (!this.loadFromBinaryFileCheckFileSize()) return false;
		this.header.magicNumber = this.readByteNumber(4);
		if (pomeraDicEnum.model[this.modelId].MAGIC_NUMBER != this.header.magicNumber) {
			this.lastError = "|t@Cł͂܂";
			return false;
		}
		stream.Position = pomeraDicEnum.num.user.HEADER_START;
		this.userWord.header.size = this.readByteNumber(2);
		this.userWord.header.count = this.readByteNumber(2);
		for(var i=0 ; i<pomeraDicEnum.num.user.OFFSET_COUNT ; i++){
			this.userWord.header.offset[i] = this.readByteNumber(2);
		}
		var endPos = stream.Position + this.userWord.header.size;
		var readCount = 0;
		while (this.userWord.header.count
			&& readCount < this.userWord.header.count
			&& stream.Position < endPos
			&& !stream.EOS) {
			var item = new PomeraDicUserWord();
			this.userWord.data.push(item);
			//OX擾
			item.len = this.readByteNumber(1);
			if (item.len & 0x80) { //ʖi1rbgĂj
				item.len &= 0x7F //Ă1rbgoff
			} else {
				item.hinshi = null;
			}
			//ǂ݉擾
			item.ylen = this.readByteNumber(1);
			//ǂ݉擾
			item.yomi_bin = stream.Read(item.ylen);
			item.yomi_han = this.binObj.binToStr(item.yomi_bin, "SJIS");
			item.yomi_zen = convert_hanTozen(item.yomi_han);
			var wordLen = item.len - 1 - item.ylen;
			if (item.hinshi != pomeraDicEnum.num.user.HINSHI_IPPAN) wordLen -= 1;
			item.word_bin = stream.Read(wordLen);
			item.word_str = this.binObj.binToStr(item.word_bin, "SJIS");
			if (item.hinshi != pomeraDicEnum.num.user.HINSHI_IPPAN) item.hinshi = this.readByteNumber(1);
		}
		return true;
	} catch(e) {
		this.lastError = common_getExceptionText(e);
		return false;
	} finally {
		stream.Close();
	}
}
/*********************************************************************
 * oCi[ĥAt@C̓ǂݍݏB
 * -------------------------------------------------------------------
 * [] fileName : tpX̃t@C
 * [߂] true:IAfalse:G[(lastErrorɃG[e)
 *********************************************************************/
PomeraDic.prototype.loadFromBinaryFileLoad = function(fileName) {
	this.lastError = null;
	try {
		this.stream.LoadFromFile(fileName);
		return true;
	} catch(e) {
		this.lastError = common_getExceptionText(e);
		return false;
	}
}
/*********************************************************************
 * oCi[ĥAt@CTCỸ`FbNBSf̃TCY
 * ƍAY郂fIDԂBY郂fȂ΁A
 * lastErrorɃG[bZ[Wݒ肳B
 * -------------------------------------------------------------------
 * [] Ȃ
 * [߂] fIDB
 *********************************************************************/
PomeraDic.prototype.loadFromBinaryFileCheckFileSize = function() {
	this.lastError = null;
	this.fileSize = this.stream.size;
	this.modelId = null;
	for (var name in pomeraDicEnum.model) {
		if (pomeraDicEnum.model[name].FILE_SIZE == this.fileSize) {
			this.modelId = name;
			break;
		}
	}
	if (!this.modelId) this.lastError = "|t@Cł͂܂";
	return this.modelId;
}
/*********************************************************************
 * oCi[ĥAoCiXg[igGfBAj
 * w̒ǂݍ݁AɕϊĕԂB
 * -------------------------------------------------------------------
 * [] len : ǂݍޒBJScripťElĎŵ
 * [߂] Ȃ
 *********************************************************************/
PomeraDic.prototype.readByteNumber = function(len) {
	var num = 0;
	for (var i=0 ; i<len ; i++) {
		var val = byteToNumber(this.stream.Read(1));
		num += val << (i*8);
	}
	return num;
}
/*********************************************************************
 * w肳ꂽeLXgt@C݂̎Ƀ[hB
 * (Ot@C̓I[vĂ̂Ƃ)
 * -------------------------------------------------------------------
 * [] fileName : tpX̃t@C
 *        encode   : R[h
 *        separator: ؂蕶B"auto"Ȃ玩
 *        replace  : ȕꍇtrueiǉȂfalsej
 * [߂] true:IAfalse:G[(lastErrorɃG[e)
 *********************************************************************/
PomeraDic.prototype.loadFromTextFile = function(fileName, encode, separator, replace) {
	this.lastError = null;
	fileSystem_writeLineLogFile("" + new Date().toHHMNSS() + " C|[g");
	fileSystem_writeLineLogFile(fileName);

	//eLXgt@Cǂݍ
	if (!fileSystem.fso.fileExists(fileName)) {
		this.lastError = "\t- w肳ꂽt@C͂܂";
		fileSystem_writeLineLogFile(this.lastError);
		return false;
	}
	var lines = fileSystem_readPlainText(fileName);
	if (!lines.length) {
		this.lastError = "\t- ̃t@C͋łB";
		fileSystem_writeLineLogFile(this.lastError);
		return false;
	}
	//Rg̐擪s͂A̎ޔ
	var dicKind = this.getDicKindImport(lines);
	fileSystem_writeLineLogFile("\t- " + (dicKind ? dicKind + "oB" : "ޕs"));

	//؂蕶autȍꍇALȐ擪s͂ċ؂蕶擾
	if (separator = "auto") separator = this.getSeparatorImport(lines);
	if (separator == null) {
		this.lastError = "\t- ؂蕶𔻕ʂł܂BuʁvȊOIĂB";
		fileSystem_writeLineLogFile(this.lastError);
		return false;
	}

	//C|[g
	var remainingSize = pomeraDicEnum.model[this.modelId].FILE_SIZE - pomeraDicEnum.num.user.DATA_START;
	if (!replace) remainingSize -= this.userWord.header.size; //Po^ɎgcTCY
	var allWordList = this.makeAllWordList(replace); //d`FbNpDictionary
	var newWordList = new Array(); //Pi[pz
	//Pt@C̃f[^s͗pK\p^[
	var re = new RegExp("^([^" + separator + "]+)" + separator + "(.+)" + separator + "([^" + separator + "\*\$]+)[\*\$]*$");

	//C|[gs
	var errorCount = 0;
	var successCount = 0;
	try {
		//Y鎫̕iΉ\ǂݍ
		var hinshiDefine = this.readHinshiDefine(dicKind);

		fileSystem_writeLineLogFile("");
		fileSystem_writeLineLogFile("---------- C|[gJn ----------");
		for (var i=0 ;i<lines.length ; i++) {
			var line = lines[i].trim();
			if (!line.length) continue; //󔒍s
			if (line.match(/^!+/)) continue; //Rgs
			var wordObj = null;
			try { //ăoCit@Cw肵ꍇ͂ŃG[ɂȂ
				wordObj = this.analyzeImportLine(lines[i], re, hinshiDefine);
			} catch(e) {
				fileSystem_writeLineLogFile("!! " + (i+1) + "sڂŃG[B");
				throw e;
			}
			if (!wordObj) { //͂łȂ
				errorCount++;
				continue;
			}
			//o^ς݃`FbN
			var key = wordObj.yomi_han + "\t" + wordObj.word_str;
			if (allWordList.Exists(key)) {
				fileSystem_writeLineLogFile(line);
				fileSystem_writeLineLogFile("!! ɓo^Ă܂B");
				errorCount++;
				continue;
			}
			//TCY߃`FbN
			if ((remainingSize - (wordObj.len + 1)) <= 0) {
				fileSystem_writeLineLogFile(line);
				fileSystem_writeLineLogFile("!! o^\TCY𒴉߂Ă܂߁Ǎȍ~𖳎܂B");
				errorCount++;
				break;
			}
			newWordList.push(wordObj);
			remainingSize -= wordObj.len + 1
			allWordList.Add(key, null);
			successCount++;
		}
		//o^P̒u܂͒ǉ
		if (replace) {
			this.userWord.data = newWordList;
		} else {
			this.userWord.data = this.userWord.data.concat(newWordList);
		}
		this.userWord.header.size = pomeraDicEnum.model[this.modelId].FILE_SIZE
			- pomeraDicEnum.num.user.DATA_START
			- remainingSize;
		this.userWord.header.count = this.userWord.data.length;
		this.userWord.data.sort(this.sortUserWord);
		if (errorCount) alert("G[" + errorCount + "܂BOt@C̓emFĂB");
		return true;
	} catch(e) {
		this.lastError = common_getExceptionText(e);
		return false;
	} finally {
		fileSystem_writeLineLogFile("---------- C|[gI ----------");
		fileSystem_writeLineLogFile("");
	}
}
/*********************************************************************
 * eLXg[ĥAd`FbNpDictionary쐬鏈B
 * L[͔pǂ݁{^u{PBl͎gpȂ̂nullB
 * -------------------------------------------------------------------
 * [] replace : u[h
 * [߂] DictionaryIuWFNg
 *********************************************************************/
PomeraDic.prototype.makeAllWordList = function(replace) {
	var list = new ActiveXObject("Scripting.Dictionary");
	if (replace) return list;
	for (var i=0 ; i<this.userWord.data.length ; i++) {
		var item = this.userWord.data[i];
		var key = item.yomi_han + "\t" + item.word_str;
		if (!list.Exists(key)) list.Add(key, null);
	}
	return list;
}
/*********************************************************************
 * eLXg[ĥALȃf[^ssAǂ݁APAiA
 * ɕ鏈B
 * -------------------------------------------------------------------
 * [] line : f[^s
 *        re : ͗p̐K\p^[IuWFNg
 *        hinshiDefine : iΉ\IuWFNg
 * [߂] PomeraDicUserWordIuWFNgBG[null
 *********************************************************************/
PomeraDic.prototype.analyzeImportLine = function(line, re, hinshiDefine) {
	//ǂ݁APAiAɕ
	if (!line.match(re)) {
		try {
			fileSystem_writeLineLogFile(line); //oCiAsȃf[^ꍇ͂ŗO
			fileSystem_writeLineLogFile("!! ͂ł܂B");
		} catch(e) {}
		throw "w肳ꂽt@C͂łȂߏ𒆎~܂B\nOt@C̓emFĂB";
	}
	var yomi = RegExp.$1;
	var word = RegExp.$2;
	var hin  = RegExp.$3;
	//PɐR[h܂܂ĂG[
	if (word.match(/[\x00-\x1F]/)) {
		fileSystem_writeLineLogFile(line);
		fileSystem_writeLineLogFile("!! PɎgpłȂ܂܂Ă܂B");
		return null;
	}
	//Ήi|ɂ邩
	if (hinshiDefine[hin] === undefined) {
		fileSystem_writeLineLogFile(line);
		fileSystem_writeLineLogFile("!! |̕isłBʖƂď܂B");
		hin = pomeraDicEnum.num.user.HINSHI_IPPAN;
	}
	//ǂ݉̐擪`FbN
	var s = yomi.substr(0,1);
	var han = convert_zenTohan(s);
	if (!han.length) { //pɕϊłȂ
		fileSystem_writeLineLogFile(line);
		fileSystem_writeLineLogFile("!! " + s + "͓ǂ݂ɎwłȂłB");
		return null;
	}
	if (pomeraDicUserWord_yomiValidLetterTop.indexOf(han.substr(0,1)) < 0) {
		fileSystem_writeLineLogFile(line);
		fileSystem_writeLineLogFile("!! " + s + "͓ǂ݂̐擪ɎwłȂłB");
		return null;
	}
	//ǂ݉̐擪ȊO̕`FbN
	for (var i=1 ; i<yomi.length ; i++) {
		var s = yomi.substr(i,1);
		var han = convert_zenTohan(s);
		if (!han.length) {
			fileSystem_writeLineLogFile(line);
			fileSystem_writeLineLogFile("!! " + s + "͓ǂ݂ɎwłȂłB");
			return null;
		}
		for (var j=0 ; j<han.length ; j++) {
			if (pomeraDicUserWord_yomiInvalidLetterBody.indexOf(han.substr(j,1)) < 0) {
				fileSystem_writeLineLogFile(line);
				fileSystem_writeLineLogFile("!! " + s + "͓ǂ݂ɎwłȂłB");
				return null;
			}
		}
	}
	//f[^IuWFNgɐݒ
	var item = new PomeraDicUserWord();
	item.yomi_zen = convert_hiraTokata(convert_hanTozen(yomi));
	item.yomi_zen = item.yomi_zen.replace(/^/g, "E"); //XbV͒ɕϊ
	item.yomi_han = convert_zenTohan(item.yomi_zen);
	item.word_str = (word.match(/^"(.*)"$/) ? RegExp.$1 : word); //""ň͂܂Ă΂͂
	item.hinshi = hinshiDefine[hin];
	//ǂ݉̃`FbN
	var yomi_bin = this.binObj.strToBin(item.yomi_zen);
	if (yomi_bin.bytes > pomeraDicEnum.num.user.YOMI_LEN_MAX) {
		fileSystem_writeLineLogFile(line);
		fileSystem_writeLineLogFile("!! ǂ݂܂BSp8ȓɂĂB");
		return null;
	}
	//P꒷̃`FbN
	var word_bin = this.binObj.strToBin(item.word_str);
	if (yomi_bin.bytes > pomeraDicEnum.num.user.WORD_LEN_MAX) {
		fileSystem_writeLineLogFile(line);
		fileSystem_writeLineLogFile("!! Pꂪ܂BSp18ȓɂĂB");
		return null;
	}
	//oCil̃Zbg
	this.setBinaryUserDic(item);
	return item;
}
/*********************************************************************
 * eLXg[ĥAiΉ\t@CǂݍޏB
 * -------------------------------------------------------------------
 * [] dicKind : ̎ނ
 * [߂] iΉ\i[ObjectBiԍƕîǂł
 *        ϊł悤Avf͕iЂƂɂiԍƕîӂ
 *        ƂAǂ|̕iԍێ
 *********************************************************************/
PomeraDic.prototype.readHinshiDefine = function(dicKind) {
	var dirPath = fileSystem.fso.getParentFolderName(fileSystem.scriptFileName.full) + "\\hinshi\\";
	if (!dicKind || !fileSystem.fso.fileExists(dirPath + dicKind + ".txt")) {
		var msg = dicKind ? dicKind + "p̕iΉ\Ȃ" : "ނ𔻕ʂłȂ";
		fileSystem_writeLineLogFile("\t- " + msg + "߁AATOK7Ƃď܂B");
		if (fileSystem.fso.fileExists(dirPath + "ATOK7.txt")) {
			dicKind = "ATOK7";
		} else {
			fileSystem_writeLineLogFile("\t- " + dicKind + "p̕iΉ\܂B");
			throw "iΉ\܂BOt@C̓emFĂB";
		}
	}
	var define = new Object();
	var lines = fileSystem_readPlainText(dirPath + dicKind + ".txt");
	for (var i=0 ; i<lines.length ; i++) {
		var line = lines[i];
		if (line.substr(0,1)=="#") continue;
		if (!line.match(/^(\d*)\t(.*)\t(\d+)\t(.+)*$/)) throw dicKind + "p̕iΉ\słB";
		if (!RegExp.$1) continue;
		define[RegExp.$1 - 0] = RegExp.$3 - 0;
		define[RegExp.$2] = RegExp.$3 - 0;
	}
	return define;
}
/*********************************************************************
 * eLXg[ĥA؂蕶autȍꍇɗLȐ擪s
 * ͂ċ؂蕶擾鏈BpJ}ASpǓ_A^uʉ\B
 * -------------------------------------------------------------------
 * [] lines : [heLXgt@C̊esvfɎz
 * [߂] ؂蕶BołȂnull
 *********************************************************************/
PomeraDic.prototype.getSeparatorImport = function(lines) {
	var dataLine = null;
	for (var i=0 ; i<lines.length ; i++) {
		var line = lines[i].trim();
		if (!line.length) continue; //󔒍s
		if (line.match(/^!+/)) continue; //Rgs
		if (line.length < 5) break; //mɎf[^ł͂Ȃs
		if (lines[i].match(/^[^,A\t]+([,A\t]).+\1[^,A\t]+$/)) return RegExp.$1;
		break;
	}
	return null;
}
/*********************************************************************
 * [heLXgt@C̐擪sRgł΁A͂Ď
 * ނ擾B
 * -------------------------------------------------------------------
 * [] lines : [heLXgt@C̊esvfɎz
 * [߂] ȉ̌`̂̕ꂩB擾łȂnull
 *        ATOK8AATOKPOMERAADICUTԍAATOK_TANGO_TEXT_HEADER_1
 *********************************************************************/
PomeraDic.prototype.getDicKindImport = function(lines) {
	var result = null;
	if (!lines.length) return result;
	var line = lines[0].rtrim(); //[Ú~XꍇlAꉞg~O
	if (!line.match(/^!+/)) return result; //RgsłȂΏ𔲂
	var han = convert_zenTohan(line).toUpperCase(); //!ȊO͑Sp/p/啶ŝߔp啶ɕϊĔf
	if (han == "!!ATOK_TANGO_TEXT_HEADER_1") {
		result = "ATOK_TANGO_TEXT_HEADER_1";
		lines.shift(); //擪vf폜
	} else if (han.match(/^!((ATOK)(8|POMERA)|!(DICUT)(\d{1,2}))\s*$/i)) {
		kind = (RegExp.$2.length ? RegExp.$2 : RegExp.$4);
		ver  = (RegExp.$3.length ? RegExp.$3 : RegExp.$5);
		result = kind + ver;
		lines.shift(); //擪vf폜
	}
	return result;
}
/*********************************************************************
 * ݂̃f[^et@Cɏo͂B
 * -------------------------------------------------------------------
 * [] fileName : tpX̃t@C
 *        clearLearned : wKʂNA邩
 * [߂] true:IAfalse:G[(lastErrorɃG[e)
 *********************************************************************/
PomeraDic.prototype.saveToBinaryFile = function(fileName, clearLearned) {
	this.lastError = null;
	if (!this.header.magicNumber) {
		this.lastError = "Ă܂";
		return false;
	}
	this.setBinaryUserDicAll();
	this.userWord.data.sort(this.sortUserWord);
	var byteArray = this.binObj.binArray;
	var stream = this.stream;
	stream.Type = adoEnums.streamType.adTypeBinary;
	stream.Open();
	try {
		this.updateUserWordOffset();
		//}WbNio[(4oCg)
		var wk = this.numToIndexArray(this.header.magicNumber, 4);
		for (var i=0 ; i<wk.length ; i++) {
			stream.write(byteArray[wk[i]]);
		}
		//`FbNT(4oCg)BƂ肠nulloCg
		stream.write(byteArray[0x00]);
		stream.write(byteArray[0x00]);
		stream.write(byteArray[0x00]);
		stream.write(byteArray[0x00]);
		//gp̈(4oCg)
		stream.write(byteArray[0x00]);
		stream.write(byteArray[0x00]);
		stream.write(byteArray[0x00]);
		stream.write(byteArray[0x00]);
		//wK
		if ((this.original == null) || clearLearned) {
			for(var i=pomeraDicEnum.num.data.START ; i<pomeraDicEnum.num.user.HEADER_START ; i++){
				stream.write(byteArray[0x00]);
			}
		} else {
			stream.write(this.binObj.sliceBin(this.original, pomeraDicEnum.num.data.START, pomeraDicEnum.num.learned.SIZE));
		}
		//[Uwb_FPo^̈TCY
		wk = this.numToIndexArray(this.userWord.header.size, 2);
		stream.write(byteArray[wk[0]]);
		stream.write(byteArray[wk[1]]);
		//[Uwb_Fo^Pꐔ
		wk = this.numToIndexArray(this.userWord.header.count, 2);
		stream.write(byteArray[wk[0]]);
		stream.write(byteArray[wk[1]]);
		//[Uwb_FItZbg
		var offsetArray = this.userWord.header.offset;
		for(var i=0 ; i<offsetArray.length ; i++){
			wk = this.numToIndexArray(offsetArray[i], 2);
			stream.write(byteArray[wk[0]]);
			stream.write(byteArray[wk[1]]);
		}
		//[U{
		for (var i=0 ; i<this.userWord.data.length ; i++) {
			var item = this.userWord.data[i];
			if ((stream.Position + item.len) >= this.fileSize) break;
			if (item.hinshi == pomeraDicEnum.num.user.HINSHI_IPPAN) item.len |= 0x80;
			stream.write(byteArray[item.len]);
			stream.write(byteArray[item.ylen]);
			stream.write(item.yomi_bin);
			stream.write(item.word_bin);
			if (item.hinshi != pomeraDicEnum.num.user.HINSHI_IPPAN) stream.write(byteArray[item.hinshi]);
		}
		while (stream.Position < this.fileSize){
			stream.write(byteArray[0x00]);
		}
		//`FbNT
		var csum = 0;
		stream.Position = pomeraDicEnum.num.data.START;
		while (!stream.EOS) {
			csum += byteToNumber(stream.Read(1));
		}
		stream.Position = pomeraDicEnum.num.head.CHECK_SUM_START;
		var wk = this.numToIndexArray(csum, 4);
		for (var i=0 ; i<wk.length ; i++) {
			stream.write(byteArray[wk[i]]);
		}
		//tH_݂Ȃꍇ͍쐬
		fileSystem_createAllFolder(fileSystem.fso.getParentFolderName(fileName));
		stream.SaveToFile(fileName, adoEnums.saveOptions.adSaveCreateOverWrite);
		return true;
	} catch(e) {
		this.lastError = common_getExceptionText(e);
		return false;
	} finally {
		stream.Close();
	}
}
/*********************************************************************
 * [Uo^P(PomeraDicUserWord)̃oCi֘Aڂݒ肷B
 * OɁAǂ(yomi_hanAyomi_zen)AP(word_str)Ai(hinshi)
 * ݒ肳Ă̂ƂAȊO̍ڂXVB
 * -------------------------------------------------------------------
 * [] item : [Uo^P
 * [߂] Ȃ
 *********************************************************************/
PomeraDic.prototype.setBinaryUserDic = function(item) {
	item.len = 1; //ǂ݉̒

	//pǂ݉oCiɕϊ
	var result = this.binObj.strToBin(item.yomi_han);
	item.yomi_bin = result.bin; //oCi
	item.ylen = result.bytes;   //oCĩoCg
	item.len += item.ylen;

	//o^PoCiɕϊ
	var result = this.binObj.strToBin(item.word_str, "SJIS");
	item.word_bin = result.bin; //oCi
	item.len += result.bytes;   //oCĩoCg

	//ʖȊOȂAip(1oCg)Z
	if (item.hinshi != pomeraDicEnum.num.user.HINSHI_IPPAN) item.len += 1;
}
/*********************************************************************
 * [Uo^P(this.userWord.data)̑Svf̃oCi֘Aڂ
 * ݒ肷BOɁAǂ(yomi_hanAyomi_zen)AP(word_str)A
 * i(hinshi)ݒ肳Ă̂ƂAȊO̍ڂXVB
 * wb_̃TCY(this.userWord.header.size)XVB
 * -------------------------------------------------------------------
 * [] Ȃ
 * [߂] Ȃ
 *********************************************************************/
PomeraDic.prototype.setBinaryUserDicAll = function() {
	this.userWord.header.size = 0;
	for (var i=0 ; i<this.userWord.data.length ; i++) {
		var item = this.userWord.data[i];
		this.setBinaryUserDic(item);
		this.userWord.header.size += item.len + 1;
	}
}
/*********************************************************************
 * [Uo^P̃\[gpBArraysort֐̈ɎwB
 * pǂ݉ѓo^Pő召rB
 * -------------------------------------------------------------------
 * [] item1 : vf1
 *        item2 : vf2
 * [߂] rʁB0:A-1:vf1<vf2A1:vf1>vf2
 *********************************************************************/
PomeraDic.prototype.sortUserWord = function(item1, item2) {
	if (item1.yomi_han < item2.yomi_han) {
		return -1;
	} else if (item1.yomi_han > item2.yomi_han) {
		return 1;
	}
	if (item1.word_str < item2.word_str) {
		return -1;
	} else if (item1.word_str > item2.word_str) {
		return 1;
	}
	return 0;
}
/*********************************************************************
 * [Uo^P̓eŁAItZbgXVB
 * -------------------------------------------------------------------
 * [] Ȃ
 * [߂] Ȃ
 *********************************************************************/
PomeraDic.prototype.updateUserWordOffset = function() {
	this.resetUserWordOffset();
	var pos = 0;
	for (var i=0 ; i<this.userWord.data.length ; i++) {
		var item = this.userWord.data[i];
		var s = item.yomi_han.substr(0, 1);
		var idx = pomeraDicUserWordOffsetIndex[s];
		if (idx == null) throw "ǂ݂ɎwłȂ܂܂Ă܂F" + item.yomi_han;
		if (this.userWord.header.offset[idx] == pomeraDicEnum.num.user.OFFSET_DEFAULT) {
			this.userWord.header.offset[idx] = pos;
		}
		pos += 1 + item.len;
	}
}
/*********************************************************************
 * ݂̃f[^êA[Uo^PeLXgt@Cɏo͂B
 * -------------------------------------------------------------------
 * [] fileName : tpX̃t@C
 *        encode   : GR[hBadoEnums.streamCharset̃L[
 *        separator: ؂蕶
 *        quote    : Pɖœdp邩
 * [߂] true:IAfalse:G[(lastErrorɃG[e)
 *********************************************************************/
PomeraDic.prototype.saveToTextFile = function(fileName, encode, separator, quote) {
	this.lastError = null;
	if (!this.header.magicNumber) {
		this.lastError = "f[^͋ł";
		return false;
	}
	try {
		fileSystem_createAllFolder(fileSystem.fso.GetParentFolderName(fileName));
	} catch(e) {
		this.lastError = "tH_쐬ł܂B";
		return false;
	}
	this.userWord.data.sort(this.sortUserWord);
	if (!adoEnums.streamCharset[encode]) encode = "SJIS";
	var re = new RegExp(separator); //Pꒆɋ؂蕶p^[
	var reQuote = new RegExp('^".*"$'); //Pꂪ""ň͂܂Ăp^[
	var stream = this.stream;
	stream.Type = adoEnums.streamType.adTypeText;
	stream.charset = adoEnums.streamCharset[encode];
	stream.Open();
	try {
		//[eBeBŗL̃wb_
		stream.writeText("!ATOKPOMERA", adoEnums.streamWrite.adWriteLine);
		stream.writeText("!!GNX|[g", adoEnums.streamWrite.adWriteLine);
		stream.writeText("!!Ώێ;" + (this.originalFileName ? this.originalFileName : "Ȃ")
			, adoEnums.streamWrite.adWriteLine);
		stream.writeText("!!f;" + this.modelId, adoEnums.streamWrite.adWriteLine);
		stream.writeText("!!؂蕶;" + (separator == "\t" ? "^u" : separator)
			, adoEnums.streamWrite.adWriteLine);
		stream.writeText("!!o͒Pꐔ;" + this.userWord.header.count
			, adoEnums.streamWrite.adWriteLine);
		stream.writeText("!!o͓;" + new Date().toYYYYMMDD_HHMNSS()
			, adoEnums.streamWrite.adWriteLine);
		stream.writeText("", adoEnums.streamWrite.adWriteLine);
		//[U{
		for (var i=0 ; i<this.userWord.data.length ; i++) {
			var item = this.userWord.data[i];
			stream.writeText(convert_kataTohira(item.yomi_zen) + separator);
			var word = item.word_str;
			if (quote || word.match(re) || word.match(reQuote)) word = '"' + word + '"';
			stream.writeText(word + separator);
			var hinshi = pomeraDicHinshiList[item.hinshi];
			stream.writeText((hinshi ? pomeraDicHinshiList[item.hinshi] : "s")
				, adoEnums.streamWrite.adWriteLine);
		}
		return true;
	} catch(e) {
		this.lastError = common_getExceptionText(e);
		return false;
	} finally {
		//ۂɂ炸t@Cóiǂ܂Őɏł킩₷̂Łj
		try {
			stream.SaveToFile(fileName, adoEnums.saveOptions.adSaveCreateOverWrite);
		} catch(e) {}
		stream.Close();
	}
}
/*********************************************************************
 * 1oCg`4oCg̐A1oCgPʂ̐lɕĕԂB
 * ʂ̕т͉ʁʃoCgigGfBAj
 * ()
 *  0xFF -------> [FF,0,0,0]
 *  0xFFFF -----> [FF,FF,0,0]
 *  0x10000 ----> [0,0,1,0]
 *  0xFFFFFF ---> [FF,FF,FF,0]
 *  0xFFFFFFFF -> [FF,FF,FF,15]
 *
 * JScriptł32rbg̏1rbĝ͕߁A4oCgt
 * @킯ł͂ȂA_̎TCYł͖ȂB
 * -------------------------------------------------------------------
 * [] num : 1oCg`4oCg̐
 *        len : 鐔
 * [߂] ʂi[z
 *********************************************************************/
PomeraDic.prototype.numToIndexArray = function(num, len) {
	if (len < 1) {
		len = 1;
	} else if (len > 4) {
		len = 4;
	}
	var mask = [0xff, 0xff00, 0xff0000, 0xff000000]
	var array = new Array(len);
	for (var i=0 ; i<len ; i++) {
		array[i] = (num & mask[i]) >>> i*8;
	}
	return array;
}
